
import { world, system } from "@minecraft/server";

function wait(ticks) {
    return new Promise(resolve => system.runTimeout(resolve, ticks));
}

world.beforeEvents.itemUse.subscribe(async data => {
    const player = data.source;
    if (!player || data.itemStack.typeId !== "kittysbuild:gothicspawn") return;

    for (const player of world.getPlayers()) {
        await player.runCommandAsync("playsound note.bass @s ~ ~ ~");
        await player.runCommandAsync("say Loading: §c5 §fBuild Parts");
        await player.runCommandAsync("say §l§cPlease Stay Still!");
        await player.runCommandAsync(`setblock ~ ~-1 ~ sea_lantern`);
        await player.runCommandAsync(`setblock ~ ~ ~1 sea_lantern`);
        await player.runCommandAsync(`setblock ~ ~ ~-1 sea_lantern`);
        await player.runCommandAsync(`setblock ~1 ~ ~ sea_lantern`);
        await player.runCommandAsync(`setblock ~-1 ~ ~ sea_lantern`);
    
        await player.runCommandAsync(`function GothicSpawn_part1`);
        await player.runCommandAsync(`say §bLoading Part: [§61§b/§c5§b]`);
        await wait(25);
        
        await player.runCommandAsync(`function GothicSpawn_part2`);
        await player.runCommandAsync(`say §bLoading Part: [§62§b/§c5§b]`);
        await wait(25);
        
        await player.runCommandAsync(`function GothicSpawn_part3`);
        await player.runCommandAsync(`say §bLoading Part: [§63§b/§c5§b]`);
        await wait(25);
        
        await player.runCommandAsync(`function GothicSpawn_part4`);
        await player.runCommandAsync(`say §bLoading Part: [§64§b/§c5§b]`);
        await wait(25);
        
        await player.runCommandAsync(`function GothicSpawn_part5`);
        await player.runCommandAsync(`say §bLoading Part: [§65§b/§c5§b]`);
        await wait(25);
        
        await player.runCommandAsync("say §6Build Completed! Be Sure To Check The Far Side Of The Build Fully Spawned");
        await player.runCommandAsync("playsound note.pling @s ~ ~ ~");
    }
});
